package applications.trakla2.datalogging;


/*
 * 
 * @author Otto Seppl
 *
 * GradeData and SubmissionData have a load of same methods not in their superclasses
 * but they are essentially the very same class. This class is a kind of a wrapper class
 * for transforming between the two without touching the classes themselves. Touching the
 * classes is risky, as all the stored submissions are made with these classes.
 */
public class GradeToSubmissionData extends SubmissionData {

    private static final long serialVersionUID = 8347078882786194541L;

    public String operationName() { return "grade"; }
    
    public GradeToSubmissionData(GradeData gd){
        setStudentSolution(gd.getStudentSolution());
        setSeed(gd.getSeed());
        setGrade(gd.getGrade());
        setCourseCode(gd.getCourseCode());
        setExerciseClassName(gd.getExerciseClassName());
        setExerciseNumber(gd.getExerciseNumber());
        setFileName(gd.getFileName());
        setFingerprint(gd.getFingerprint());
        setMaxPoints(gd.getMaxPoints());
        setRound(gd.getRound());
        setStudentid(gd.getStudentid());
        setTimeStamp(gd.getTimeStamp());        

        //AND HERE IS THE ONE AND ONLY DIFFERENCE,
        //setErroneousStepIndex(gd.getErroneousStepIndex()); 
    }
    
}
