
package applications.trakla2.server;


import java.io.*;

import applications.trakla2.datalogging.ExerciseData;

public class ObjectSerializer {

    Object fileDirLock = new Object();

    ExerciseServerImpl server;
    String submittedFilesPrefix;

    protected ObjectSerializer(ExerciseServerImpl server) throws IOException {
        this.server = server;
        submittedFilesPrefix = ExerciseServerImpl.dataDir + "/submitted-files";

    }



    // this is not really unique, but we can live with it!
    protected long nextOid()  {
       return new java.util.Date().getTime();
    }



    protected String save(ExerciseData data) {

        try {
            String fileDir = fileDir(data);

            String fileName = fileDir + "/" + nextOid();

            FileOutputStream out = new FileOutputStream(fileName);
            ObjectOutputStream s = new ObjectOutputStream(out);
            s.writeObject(data);
            s.flush();
            s.close();

            return fileName;

        } catch (IOException e ) {
            ExerciseServerImpl.error(e.getMessage());
            e.printStackTrace(ExerciseServerImpl.errorLog);
            return "ERROR: " + e.getMessage();
        }
    }



    private String fileDir(ExerciseData data) throws IOException {
        StringBuffer buf = new StringBuffer();
        buf.append(submittedFilesPrefix);
        buf.append("/");
        buf.append(data.getCourseCode());
        buf.append("/" + data.getRound());
        buf.append("/" + data.getExerciseNumber());
        buf.append("/" + data.getStudentid());
        buf.append("/" + data.getClass().getName());
        String fileDir = buf.toString();
        synchronized (fileDirLock) {
            File dir = new File(fileDir);
            if (!dir.isDirectory()) {
                dir.mkdirs();
            }
        }
        return fileDir;

    }



}
