package applications.trakla2.server;

import java.security.*;
import java.util.Map;

import applications.trakla2.datalogging.SubmissionData;

/** Abstract superclass for all the classes that handle the submissions. */
public abstract class SubmissionHandler {
    private String fingerPrint = null;

    /** Method called by ExerciseSessionImpl when student submits an
     * answer. */
    public abstract Map submitExercise(SubmissionData data) throws Exception;

    /** Calculates MD5 checksum for the given String. */
    protected static String calculateMD5(String s) throws NoSuchAlgorithmException  {
	MessageDigest md5Digest = MessageDigest.getInstance("MD5");
	return asHex(md5Digest.digest(s.getBytes()));
    } 

    protected String getFingerPrint() {
	if (fingerPrint == null) {
	    fingerPrint = System.getProperty("trakla2.server.FINGERPRINT");
	}
	return fingerPrint;
    }
    
    protected static String asHex(byte[] b) {
        char hex[] = {'0','1','2','3','4','5','6','7','8','9','a','b','c','d','e','f'};
	
	StringBuffer resultString= new StringBuffer();
	for (int i=0; i<b.length;i++){
	    resultString.append(hex[(b[i]>>4)&15]);
	    resultString.append(hex[b[i]&15]);
	}
        return resultString.toString();
    }    
}
