package applications.trakla2.ui;

import java.awt.*;
import java.rmi.registry.*;

import applications.trakla2.server.ExerciseServer;


class ConnectionThread extends Thread {

    Trakla2ExerciseApplet applet;

    ConnectionThread( Trakla2ExerciseApplet applet_) {
	applet = applet_;
    }
    
    public void run() {
	try {
	    Registry r = LocateRegistry.getRegistry(applet.host, applet.port);
	    ExerciseServer server = (ExerciseServer) r.lookup(ExerciseServer.SERVICE_NAME);
	    applet.setRemoteExerciseSession(server.newSession());
	} catch (Exception e) {
	    Panel p = new Panel();
	    p.add(new Label("ERROR: can not open connection to server.\n" +
	        "Possible reasons for this are:\n" +
	        " * the server is down for maintenance\n" +
	        " * a firewall blocked the connection\n" +
	        " * the applet was not retrieved from the TRAKLA2 server.\n" +
	        "Try again later and inform the system administrators if the problem persists."));
	    applet.getContentPane().add(p);
	    System.err.println("ERROR: can not open connection to server: " 
			       + e.getMessage());
	    applet.validate();
	}
    }
}

    
