package applications.trakla2.ui;


import java.rmi.RemoteException;

import matrix.util.Note;


class IdleLoggingThread extends Thread {


    /* if user is idle more than 1 minutes, then save
    message to the server */
    public static final long IDLE_TIMEOUT = 60*1000;

    public static final long SLEEPING_TIME = 1000;

    Trakla2ExerciseApplet applet;

    IdleLoggingThread( Trakla2ExerciseApplet applet_) {
        applet = applet_;
    }



    public void run() {
        boolean idle = false;
        while (true) {
            try {
                sleep(SLEEPING_TIME);
            } catch (InterruptedException e) {    }

            long idleTime = applet.idleTime();
            if (!idle && idleTime >= IDLE_TIMEOUT) {
                idle = true;
                try {
                    applet.getRemoteExerciseSession().startIdle();
                } catch (RemoteException e) {
                    Note.show(this, "ERROR: cannot connect to server");
                    Note.err(this, e.getMessage());
                }
            }
            else if (idle && idleTime < IDLE_TIMEOUT) {
                idle = false;
                try {
                    applet.getRemoteExerciseSession().endIdle();
                } catch (RemoteException e) {
                    Note.show(this, "ERROR: cannot connect to server");
                    Note.err(this, e.getMessage());
                }
            }
        }
    }



    private int minutes(long ms) {
        return (int)ms / (1000*60);
    }


}

