package applications.trakla2.ui;

import java.awt.*;
import java.util.Date;


class TimerThread extends Thread {

    Trakla2ExerciseApplet applet;
    ConnectionThread connT;

    TimerThread( Trakla2ExerciseApplet applet_, ConnectionThread connT) {
	applet = applet_;
    }
    
    public void run() {
	Date startTime = new Date();
	while (applet.getRemoteExerciseSession() == null 
	       && new Date().getTime() - startTime.getTime() < 1000*Trakla2ExerciseApplet.CONNECTION_TIMEOUT) {		
	    try {
		Thread.sleep(100);
	    } catch (InterruptedException e) {}
	}
		    
	// connection thread t1 is blocked
	if (applet.getRemoteExerciseSession() == null) { // && connT.isAlive()) {
	    Panel p = new Panel();
	    p.setLayout(new GridLayout(6,1));
	    p.add(new Label("ERROR: can not open connection to server."));
	    p.add(new Label("Possible reasons for this are"));
	    p.add(new Label(" * the server is down for maintenance"));
	    p.add(new Label(" * a firewall blocked the connection"));
	    p.add(new Label(" * the applet was not retrieved from the TRAKLA2 server."));
	    p.add(new Label("Try again later and inform the system administrators if the problem persists."));
        applet.getContentPane().add(p);
        applet.validate();
	    //	    applet.add(new Label("\nERROR: can not open connection to server.")); 
	    System.err.println("ERROR: can not open connection to server. Connection timeout.");
	    return;	
	} 
		    
	// connection thread t1 has finished succesfully
	else if (applet.getRemoteExerciseSession() != null) {
	    applet.init2();
	}
    }
    
    
}

    
