
package applications.trakla2.ui;

import java.awt.*;
import java.awt.event.*;
import java.util.Map;
import javax.swing.*;

import prototype.ui.GradeDialog;

import content.assessment.Judgement;

public class Trakla2GradeDialog extends GradeDialog {

    private boolean submitOk = false;

    private int grade = 0;

    private Trakla2ExerciseApplet applet; 

    //private StringBuffer buf;

    private int submissionCount = 0;

    protected JButton submitButton;
    protected JButton contButton;

    protected JLabel buttonInfo;


    public Trakla2GradeDialog(Judgement j, int grade, Trakla2ExerciseApplet a) {
        super(j);
        this.applet = a;
        this.grade = grade;

        // buf created in super
        //buf = new StringBuffer();
        buf.append("\nYour grade is ");
        buf.append(grade+" / ");
        buf.append(applet.getMaxPoints()+".");
//      if (j.isComplete()) {
//      buf.append("\nRemember to submit your answer!");
//      }
        //text.append(buf.toString());
        validate();


        // save log
        //applet.logGrade(grade);
        // Submit exercise
        submit();
    }


    protected JTextArea makeTextArea() {

        JTextArea t = new JTextArea("", ROWS, COLUMNS);
        t.enableInputMethods(false);
        t.setEditable(false);
        return t;
    }



    protected JPanel makeButtonPanel() {

        JPanel buttonPanel = new JPanel();
        buttonPanel.setLayout(new FlowLayout());

        submitButton = new JButton("retry");
        submitButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                submit();
            }
        });
        submitButton.setEnabled(false);
        buttonPanel.add(submitButton);

        contButton = new JButton("Close");
        contButton.addActionListener(new ActionListener() {
            public void actionPerformed(ActionEvent evt) {
                close();
            }
        });
        contButton.setEnabled(true);
        buttonPanel.add(contButton);


        return buttonPanel;
    }


    protected void submit() {
        if (applet == null) throw new IllegalStateException("Trakla2ExerciseApplet not set");
        try {
            text.append("\n\nSubmitting...\n(If submission takes more than 30 seconds, then there might be problems with internet firewalls.)\n\n");
            validate();
            Map receipt = applet.submit(grade);
            if (((Boolean)receipt.get("operationOk")).booleanValue()) {
                submitOk = true;
                //text.append((String)receipt.get("message"));
                text.setText("\nSubmission succeeded!  \n\n");
                text.append(buf.toString());
                submitButton.setEnabled(false);
            } else {
                text.append("\nERROR: Submission did not succeed: \n");
                text.append((String)receipt.get("message"));
                submitButton.setEnabled(true);
            }
            //buttonPanel.remove(submitButton);
            //submitButton.setEnabled(false);
            contButton.setText("Close");
            //	    contButton.repaint();
            //buttonPanel.repaint();
            //repaint();
            //buttonPanel.validate();
            validate();
        } catch (Exception e) {
            text.append("\nERROR: Submission did not succeed:\n " + e.getMessage());
        }

    }

    public boolean submitOk() {
        return submitOk;
    }

    protected void close() {
        super.close();
    }

    // disabled functionality from superclass
    protected void text() {}

}
