package applications.trakla2.ui;

import java.rmi.RemoteException;

import applications.exerciseapplet.MyModelAnswerFrame;
import applications.trakla2.datalogging.ModelAnswerData;

import content.interfaces.SimulationExerciseModel;

import matrix.util.Note;

public class Trakla2ModelAnswerFrame extends MyModelAnswerFrame {
    Trakla2ExerciseApplet applet;

    public Trakla2ModelAnswerFrame(Trakla2ExerciseApplet applet, SimulationExerciseModel ex) {
        super(ex);
        this.applet = applet;
    }



    public void close() {
        ModelAnswerData data = new ModelAnswerData();
        data.setAnimationStepIndices(getAnimationStepIndices());
        try {
            applet.getRemoteExerciseSession().modelAnswerClosed(data);
        } catch (RemoteException e) {
            Note.show(this, "ERROR: cannot connect to server.");
        }
        super.close();
    }



    public void validate() {
        super.validate();
        if (applet != null)
            applet.updateOperationTime();
    }


}
