package applications.trakla2.ui;

import java.applet.Applet;
import java.awt.*;
import java.awt.event.*;
import java.io.*;
import java.net.*;

import applications.trakla2.datalogging.SubmissionData;

import matrix.animation.*;
import matrix.uitools.StructurePanel;
import matrix.util.configuration.MatrixConfiguration;



public class ViewerApplet extends Applet {

    public static final String USERID = "trakla2-adm";
    public static final char[] PASSWD = {'k','s','k','w','t','r','2'};


    TextField urlField = new TextField("", 40);
    //TextField courseCodeF = new TextField();
    //TextField roundF = new TextField();
    //TextField exerciseNumberF = new TextField();
    //TextField studentidF = new TextField();
    Panel bottomPanel = new Panel();


    public void init() {
        // Install Authenticator
        //Authenticator.setDefault (new MyAuthenticator ());

        MatrixConfiguration.setCodebaseURL(getCodeBase().toString());

        Panel upperPanel = new Panel();
        //upperPanel.add(new Label("course code: "));
        //upperPanel.add(courseCodeF);

        //upperPanel.add(new Label("round: "));
        //upperPanel.add(roundF);

        //upperPanel.add(new Label("exercise number: "));
        //upperPanel.add(exerciseNumberF);

        //upperPanel.add(new Label("studentid: "));
        //upperPanel.add(studentidF);
        upperPanel.add(new Label("URL:"));
        upperPanel.add(urlField);
        Button get = new Button("Get");
        get.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent evt) {
                    getIt();
                }
            });
        upperPanel.add(get);

        setLayout(new GridBagLayout());

        GridBagConstraints gbc = new GridBagConstraints();


        gbc.gridx = 0;
        gbc.gridy = 0;
        gbc.gridwidth = 1;
        gbc.weightx = 0.0;
        gbc.weighty = 0.0;
        gbc.fill = GridBagConstraints.NONE;
        gbc.anchor =  GridBagConstraints.NORTHWEST;
        gbc.insets = new Insets(10,10,10,10);

        add(upperPanel,gbc);


        gbc.gridx = 0;
        gbc.gridy = 1;
        gbc.gridwidth = 1;
        gbc.weightx = 0.0;
        gbc.weighty = 1.0;
        gbc.fill = GridBagConstraints.BOTH;
        gbc.anchor =  GridBagConstraints.NORTHWEST;
        gbc.insets = new Insets(10,10,10,10);



        add(bottomPanel,gbc);

    }


    public SubmissionData loadSubmission(URL url) {
        SubmissionData data = null;
        try {

            URLConnection c = url.openConnection();
            InputStream istream = c.getInputStream();
            ObjectInputStream p = new ObjectInputStream(istream);
            data = (SubmissionData)p.readObject();
            System.out.println("Loaded: " + data);
            istream.close();
        }
        catch (Exception e) {
            fatalError(e.getMessage());
            e.printStackTrace(System.err);
            return null;
        }
        return data;
    }



    //private String parseURL() {
        //StringBuffer buf = new StringBuffer();
        //buf.append("http://opus.cs.hut.fi/~trakla2/data/submitted-files/");
        //buf.append(courseCodeF.getText().trim());
        //buf.append("/");
        //buf.append(roundF.getText().trim()+"/");
        //buf.append(studentidF.getText().trim().toLowerCase());
        //buf.append("/applications.trakla2.datalogging.SubmissionData/7");
        //return buf.toString();
    //}


    public void getIt() {
        try {
            bottomPanel.removeAll();

            //String url = parseURL();
            String url = urlField.getText();
            SubmissionData data = loadSubmission(new URL(url));
            Animator a = data.getStudentSolution().getAnimator();
            Animator.setActiveAnimator(a);
            StructurePanel panel = new StructurePanel(data.getStudentSolution().getStructures(), a);

            VisualAnimator visualAnimator = new VisualAnimator(a);

            visualAnimator.setResetButtonVisible(false);
            panel.setVisualAnimator(visualAnimator);
            a.rewind();
            bottomPanel.setLayout(new GridBagLayout());
            GridBagConstraints gbc = new GridBagConstraints();

            // add animator panel
            gbc.gridx = 0;
            gbc.gridy = 0;
            gbc.gridwidth = 1;
            gbc.weightx = 0.0;
            gbc.weighty = 0.0;
            gbc.fill = GridBagConstraints.NONE;
            gbc.anchor =  GridBagConstraints.NORTHWEST;
            gbc.insets = new Insets(10,10,10,10);
            bottomPanel.add(visualAnimator, gbc);


            // add structure panel
            gbc.gridx = 0;
            gbc.gridy = 1;
            gbc.gridwidth = 1;
            gbc.weightx = 1.0;
            gbc.weighty = 1.0;
            gbc.gridwidth = 2;
            gbc.fill = GridBagConstraints.BOTH;
            gbc.anchor =  GridBagConstraints.NORTHWEST;
            gbc.insets = new Insets(10,10,10,10);

            ScrollPane sp = new ScrollPane();
            sp.add(panel);

            bottomPanel.add(sp, gbc);
            validate();

        }   catch (Exception e) {
            fatalError(e.getMessage());
            e.printStackTrace(System.err);
        }

    }


    private void fatalError(String msg) {
        removeAll();
        add(new Label("ERROR: " + msg));
        validate();
    }



    class MyAuthenticator extends Authenticator {
        protected PasswordAuthentication getPasswordAuthentication() {
            return new PasswordAuthentication (USERID, PASSWD);
        }
    }
}


