package content.exercises;

import java.util.Random;

import content.exercises.structures.ExerBin;
import content.exercises.structures.ExerBinSearchTree_DuplicatesRight;
import matrix.animation.Animator;
import matrix.structures.FDT.FDT;
import matrix.structures.FDT.probe.Key;
import matrix.structures.FDT.probe.Table;
import matrix.util.Note;

/**
 * This exercise is mostly the same as BST_Insert. The only difference is 
 * that in this exercise duplicates are added to the right subtree instead of the left subtree.
 * 
 * @author kstalnac
 *
 */
public class BST_Insert_DuplicatesRight extends BST_Insert {



    public BST_Insert_DuplicatesRight() {
        super();
    }
    
    public FDT[] init() {

        ExerBinSearchTree_DuplicatesRight testBST;
        Random R = new Random(seed);
        do {
            // 15-20 keys
            int n = Math.abs(R.nextInt()%6);
            // Can contain duplicates
            S = matrix.util.RandomKey.createNoDuplicateUppercaseRandomKey(R,15)+
                matrix.util.RandomKey.createNoDuplicateUppercaseRandomKey(R,n);
            // Maximum height 6
            testBST = new ExerBinSearchTree_DuplicatesRight();
            for(int i = 0; i < S.length(); i++)
                testBST.insert(new Key(""+S.charAt(i)));
            if (DEBUG)
                System.out.println("iteration - height "+testBST.getHeight());
        } while(testBST.getHeight() > 6);

        t = new Table(S);
        bt = new ExerBin();
        FDT[]  s = { t, bt };
        return s;
    }
    
    public FDT[] solve() {
        Note.out(this, "Solve");
        bst = new ExerBinSearchTree_DuplicatesRight();
        Table tbl = (Table)getInitialStructures()[0];
        Animator a = Animator.getActiveAnimator();
        for (int i=0; i<tbl.size(); i++) {
            a.startOperation();
            bst.insert(tbl.getObject(i));
            a.endOperation();
        }
        Note.out(this, "Solved");
        return new FDT[] { (FDT)bst.getElement() };
    }

    private static final long serialVersionUID = 1750853308433323574L;
}
