/*
* Matrix -- algorithm simulation system
* Copyright (C) 2000-2004 Matrix group
* (See the AUTHORS file and the author tag below for more information
* on the authors.)
*
* This program is free software; you can redistribute it and/or modify
* it under the terms of the GNU General Public License as published by
* the Free Software Foundation; either version 2 of the License, or
* (at your option) any later version.
*
* This program is distributed in the hope that it will be useful,
* but WITHOUT ANY WARRANTY; without even the implied warranty of
* MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
* GNU General Public License for more details.
*
* You should have received a copy of the GNU General Public License
* along with this program; if not, write to the Free Software
* Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
*/


   package content.exercises;
   import content.interfaces.*;
   import matrix.animation.Animator;
   import matrix.simulation.VisualTypeConf;
   import content.exercises.structures.*;
   import matrix.structures.FDT.FDT;
   import matrix.structures.FDT.probe.*;
   import java.util.*;


    public class CountingSort implements SimulationExerciseModel, StyledExercise, ModelAnswerNames, ConfigureVisualType, JudgeBlocks{
   
   
   //ATTRIBUTES
   
    private InvisibleKeyTable input;
      private AuxiliaryTableCounting auxTable;
      private OutputTableCounting sortTable;
     
      private long seed = 1;
      private String s;	
      private  String a;
      private  String o;   
   
   
   //METHODS
   
       public FDT[] solveThis(){
       
         FDT[] structures = getInitialStructures();
         Table tab = (InvisibleKeyTable) structures[0];
         AuxiliaryTableCounting atc = (AuxiliaryTableCounting) structures[1];
         OutputTableCounting otc= (OutputTableCounting) structures[2];
         Object g = new Object();
         int index=0,a;
         Key k;
         Animator an = Animator.getActiveAnimator();
        
         while (index<tab.size()){
         
            an.startOperation();
            
            k=(Key)tab.next();
            ((InvisibleKeyTable)tab).setSelectedKey((InvisibleKey)k);
            a = Integer.parseInt(k.toString());
            atc.setObject(g,a);
         
            an.endOperation();
            index++;
               
         }
         
         index=0;
         AuxiliaryTableCounting.CountingKey k2;
         atc.reset();
      	
         while (index<atc.size()-1){
         
            an.startOperation();
         
            k2=(AuxiliaryTableCounting.CountingKey)atc.next();
            atc.setObject(k2,index+1);
         
            an.endOperation();
            index++;
               
         }
         
      
      	      	
      	
         index=tab.size() - 1;
         tab.reset();
         Key p;
         while (index >= 0){
         
            an.startOperation();
            
            k=(Key)tab.getObject(index);
            ((InvisibleKeyTable)tab).setSelectedKey((InvisibleKey)k);
         
            p = (Key)atc.getObject(Integer.parseInt(k.toString()));
                     
            a = Integer.parseInt(p.toString());
           
            otc.setObject(k,a);
         
            an.endOperation();
            index--;
               
         }
         
      	          
         return new FDT[]{tab,atc,otc};
      }
   
     public FDT[] solve(){
       FDT[] structures = solveThis();
   	 return new FDT[]{structures[1], structures[2]};
     }
   
       public FDT[] makeModelAnswer(){
      
         return solveThis();
      
      }
       public String[] getStructureVisualisations(){
      
         return new String[]  {"array","array","array"};
      
      }
       public String[] getModelAnswerVisualisations(){
      
         return new String[] {"array","array","array"};
      
      }
       public String[] getModelAnswerNames(){
      
         return new String[] {"Input","Auxiliary Table", "Output"};
      
      }
       public VisualTypeConf[] conf(){
      
         VisualTypeConf tabl1 = new VisualTypeConf();
         tabl1.enable("matrix.visual.VisualKey", VisualTypeConf.HIGHLIGHT_OPERATION);
         tabl1.enable("matrix.visual.VisualKey", VisualTypeConf.DRAG_OPERATION);
        
         VisualTypeConf tabl2 = new VisualTypeConf();
         tabl2.enable("matrix.visual.VisualArrayComponent", VisualTypeConf.DROP_OPERATION);
         tabl2.enable("matrix.visual.VisualArrayComponent", VisualTypeConf.HIGHLIGHT_OPERATION);
         tabl2.enable("matrix.visual.VisualKey", VisualTypeConf.DRAG_OPERATION);
         tabl2.enable("matrix.visual.VisualKey", VisualTypeConf.HIGHLIGHT_OPERATION);
         
         VisualTypeConf tabl3 = new VisualTypeConf();
         tabl3.enable("matrix.visual.VisualArrayComponent", VisualTypeConf.DROP_OPERATION);
         tabl3.enable("matrix.visual.VisualArrayComponent", VisualTypeConf.HIGHLIGHT_OPERATION);
      	
      	      	
         return new VisualTypeConf[] { tabl1, tabl2, tabl3};
      
      }
      
       public FDT[] init(){
       
         s="";	
         a="0000000000";
         o="                ";
         int d[];
         d=matrix.util.RandomKey.createIntKeys(new Random(seed),0,10,16);
         
         for (int i=0;i<d.length;i++){
         
            s=s+d[i];
         
         }
       
         input = new InvisibleKeyTable(s);
         auxTable = new AuxiliaryTableCounting(a);
         sortTable = new OutputTableCounting(o,1,auxTable);
            		
         return new FDT[] { input, auxTable, sortTable };
         
         
      }
       public void setSeed(long v){
      
         this.seed = v;
      }
   
   
       public long getSeed(){
      
         return seed;
      }
   
   
       public String[] getStructureNames(){
      
         return new String[]  {"Input","Auxiliary Table", "Output"};
      
      }
       public FDT[] getAnswer(){
      
         return new FDT[]{auxTable,sortTable};
      }
   
   
       public FDT[] getInitialStructures(){
      
         AuxiliaryTableCounting b = new AuxiliaryTableCounting(a);
      
         return new FDT[] { new InvisibleKeyTable(s),b ,  new OutputTableCounting(o,1,b) };
      
      }
       public String getDescription(){
      
         return "";
      }
   
   
       static final long serialVersionUID = 7086968966105563078L;   
   }
