/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/*$Id: Tree_Huffmann.java,v 2.9 2007/04/23 09:14:52 jhhelmi2 Exp $*/

package content.exercises;

import content.exercises.components.MButton;
import content.interfaces.ModelAnswerNames;
import content.interfaces.SimulationExerciseSelfAssessment;
import content.interfaces.StyledExercise;

import matrix.structures.FDT.FDT;
import matrix.structures.FDT.probe.Table;
import matrix.util.Note;

public class Tree_Huffmann implements SimulationExerciseSelfAssessment,
					    StyledExercise, ModelAnswerNames/*, ConfigureVisualType*/ {

    public static final boolean DEBUG = false;
    private MButton nappi;

    public FDT[] init() {
	nappi = new MButton("Hiphei!");
	return new FDT[]{ nappi };
    }
    
    long seed = 1;
   

    /**
     * Get the value of seed.
     * @return value of seed.
     */
    public long getSeed() {
        return seed;
    }
    
    /**
     * Set the value of seed.
     * @param v  Value to assign to seed.
     */
    public void setSeed(long  v) {
        this.seed = v;
    }

    public String[] getStructureVisualisations() {
	String[] s = { "exercise" };
	return s;
    }
    
    
    public String[] getModelAnswerVisualisations() {
	String[] s = { "array" };
	return s;
    }

    public String[] getStructureNames() {
	String[] s = { "Button" };
	return s;
    }
    
    public String getDescription() {
	return "Press button two times. ";
    }
    
    public String[] getModelAnswerNames() {
	String[] s = { "Correct solution" };
	return s;
    }

    public int[] judge() {
	if (nappi.getCount() < 3)
	    return new int[] {nappi.getCount()};
	else
	    return new int[] {0};
    }

    

    public int getMaxPoints() {
	return 2;
    }
    
    public String getFeedbackString() {
        // TODO Auto-generated method stub
        return null;
    }

    public FDT[] getAnswer() {
	return new FDT[]{ nappi };
    }    
    
    public FDT[] solve() {
	
	Note.out(this, "Solved");

	return new FDT[]{ new Table("Plz use ur skillz") };
    }



    public FDT[] makeModelAnswer() {
	return solve();
    }


    public FDT[] getInitialStructures() {
	return new FDT[] { new MButton("Two times") };
    }
    
    public FDT[] getSimulatedStructures() {
	return new FDT[] { nappi };
    }
    

    /*
      public VisualTypeConf[] conf() {
      
      VisualTypeConf tabl = new VisualTypeConf();
      tabl.enable("matrix.visual.VisualKey", VisualTypeConf.HIGHLIGHT_OPERATION);
      tabl.enable("matrix.visual.VisualKey", VisualTypeConf.DRAG_OPERATION);
      VisualTypeConf lis = new VisualTypeConf();
      lis.enable("matrix.visual.VisualKey", VisualTypeConf.DROP_OPERATION);
      lis.enable("matrix.visual.VisualListComponent", VisualTypeConf.DROP_OPERATION);
      lis.enable("matrix.visual.VisualList", VisualTypeConf.DROP_OPERATION);
      lis.enable("matrix.visual.VisualList", VisualTypeConf.HIGHLIGHT_OPERATION);
      return new VisualTypeConf[] { tabl, lis};
      }
    */
    
    static final long serialVersionUID = 24288411234L;
}
