/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2006 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: AuxiliaryTableCounting.java,v 1.9 2006/10/18 14:48:47 vkaravir Exp $ */

package content.exercises.structures;

import matrix.structures.FDT.probe.Key;
import matrix.structures.FDT.probe.Table;
import matrix.util.Note;

/**
 * A table of Objects that can be visualised as an Array in Matrix. It is possible
 * to create a "random table", which will randomize its keys each time it is
 * refreshed from the GUI. The random table uses three letter keys.
 */
    public class AuxiliaryTableCounting extends Table {
    
     
    


    public AuxiliaryTableCounting(String s) {
         super();
         for (int i=0; i<s.length(); i++){
            super.setObject(new CountingKey(s.substring(i,i+1)), i);
         }
         //setFirst(1);
      }
   
    
       public AuxiliaryTableCounting(int[] is) {
           super();
           for (int i=0; i<is.length; i++){
               super.setObject(new CountingKey(is[i]+""), i);
            }
        }


       public void setObject(Object obj, int address) {
      
         Object o = super.getObject(address);
          
         int a = Integer.parseInt(o.toString());
         int aux;
      	
         if (obj instanceof CountingKey){
         
            aux=a+Integer.parseInt(obj.toString());
            super.setObject(new CountingKey(aux + ""),address);
         
         }
         else{
         
            aux =a + 1;                  
            super.setObject(new CountingKey(aux + ""),address);
         
         }
      }
    
       public void decrement(int address) {
        
           if (address < getFirst() || address > getLast()) {
               Note.show("Sorry", "Index out of bounds error: Auxiliary table doesn't have index " 
                   + address + ". \n\n You are not supposed to drag the elements from this table.");
               return;
           }
        
         Object o = getObject(address);
          
         int a = Integer.parseInt(o.toString());
         a--;
         super.setObject(new CountingKey(a + ""),address);
         
      
      }
   
    
       public class CountingKey extends Key {

        public CountingKey(String k) {
            super(k);
         }
        private static final long serialVersionUID = -7315187274547653062L;
      }
    
       private static final long serialVersionUID = 6958022843085995959L;
   }
