/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package content.exercises.structures;

import matrix.structures.CDT.probe.*;
import matrix.structures.FDT.*;
import matrix.structures.FDT.probe.Key;
import matrix.structures.CDT.CDT;




/**
 * List with stack for insert operation
 *
 * @author Harri Salonen
 */

public class ExerStackList extends QueueImpl {

    private Stack stack;
    public boolean DEBUG = true;
    public ExerStackList(Stack st) {
	super();
	this.stack = st;
    }

    public ExerStackList(Object key) {
	super(key);
    }

    /*
      public void setElement(Object o) {
         if (stack == null) return;
         Object temp = stack.getObject(stack.getLast());
         if (temp == null || o == null) return;
         if (DEBUG)
            System.out.println(temp+":"+o);
         if (temp.equals(o)) {
            super.setElement(o);
            stack.delete(null);
         }
      }    
    */

    public LinkedList getNewNode(Object key) {
	ExerStackList ex = new ExerStackList(stack);
	ex.setElement(key);
	if(ex.getElement() == null)
	    return null;
	else
	    return ex;
    }

    public CDT insert(Object o) {
	if (stack == null) return this;
	Object temp = stack.getTopOfStack();
	if (o == null || temp == null)
	    return this;
	if (o instanceof Key && temp == ((Key)o).getOrig()){
	    ExerStackList newNode = (ExerStackList)getNewNode(o);
	    setLastOfQueue(newNode);
	    stack.delete(o);
	    return getFirstOfQueue();
	}
	else
	    return this;
    }

    static final long serialVersionUID = 406758265481752224L;
}
