package content.exercises.structures;

import matrix.structures.FDT.probe.Key;
import matrix.structures.util.MatrixComparable;
import matrix.util.Note;

public class HeapSortHeap extends ExerHeap {
    
    private static final long serialVersionUID = -5265248577283428029L;
    
    public HeapSortHeap(int i) {
        super(i);
    }
    
    public void minHeapify(int i) {
        if (DEBUG){
            Note.out(this, "Heapify: " + i);
            Note.out(this, "lc: " + leftChild(i) + " rc: " + rightChild(i));
        }
        if(i >= keys.eval())
            return;
        MatrixComparable p = (MatrixComparable)getObject(i);
        MatrixComparable lc = (MatrixComparable)getObject(leftChild(i));
        if(leftChild(i) >= keys.eval()) {
            lc = new Key(EMPTY);
        }
        MatrixComparable rc = (MatrixComparable)getObject(rightChild(i));
        if(rightChild(i) >= keys.eval()) {
            rc = new Key(EMPTY);
        }
        // This code handles situations where the father node is null or empty
        // such a situation never happens in normal cases, but intentionally broken
        // algorithms might have such states.
        
        if (p==null || p.equals(EMPTY)){ 
            
            if ((lc == null || lc.equals(EMPTY)) &&
                    (rc == null || rc.equals(EMPTY)))
                return;
            if (lc == null || lc.equals(EMPTY)){
                swap(i, rightChild(i));
                minHeapify(rightChild(i));
                return;
            }
            
            if (rc == null || rc.equals(EMPTY)){
                swap(i, leftChild(i));
                minHeapify(leftChild(i));
                return;
            }
            
            if(lc.gt(rc)) {                
                swap(i, rightChild(i));
                minHeapify(rightChild(i));
                return;
            }
            else{                
                swap(i, leftChild(i));
                minHeapify(leftChild(i));
                return;
            }
        } // null-father code ends
        
        if(lc == null || lc.equals(EMPTY))
            return;
        if(rc == null || rc.equals(EMPTY)) { 
            if(p.gt(lc) && (lc!=null && !lc.equals(EMPTY))) {
                swap(i, leftChild(i));
                minHeapify(leftChild(i));
            }
            return;
        }
        if(lc.gt(rc)) {
            if(p.gt(rc) && (rc!=null && !rc.equals(EMPTY))) {
                swap(i, rightChild(i));
                minHeapify(rightChild(i));
            }
        } else {
            if(p.gt(lc) && (lc!=null && !lc.equals(EMPTY))) {
                swap(i, leftChild(i));
                minHeapify(leftChild(i));
            }
        }
    }
    
    
}
