/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: StackImplInfixToPostFix.java,v 1.6 2006/06/20 13:12:21 oseppala Exp $ */

package content.exercises.structures;

import matrix.structures.CDT.probe.StackImpl;

import matrix.structures.CDT.CDT;
import matrix.structures.FDT.probe.LinkedListImpl;

/**
 * A table of Objects that can be visualised as an Array in Matrix. It is possible
 * to create a "random table", which will randomize its keys each time it is
 * refreshed from the GUI. The random table uses three letter keys.
 */
public class StackImplInfixToPostFix extends StackImpl implements matrix.structures.simulationextensions.DeleteEnabled{
    
    
    public boolean shouldDelete(){
        return true;
        
    }
    
    /**
     * This delete method overrides the original delete method in StackImpl.
     * Parameter object is deleted from the stack only if it is on the top 
     * of the stack. Otherwise deletion is not done. 
     */
    public CDT delete(Object o) {
        Object topKey = ((LinkedListImpl)getTopOfStack()).getElement();
        if (topKey == o) {
            return super.delete(o);
        } else {
            return this;
        }
    }
    static final long serialVersionUID = 3498687392145647947L;
}