/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2005 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: StackImplOper.java,v 1.7 2007/09/06 08:42:07 oseppala Exp $ */

package content.exercises.structures;

import matrix.structures.CDT.CDT;
import matrix.structures.CDT.probe.StackImpl;
import matrix.structures.FDT.FDT;
import matrix.structures.FDT.probe.*;
import matrix.structures.util.MatrixComparable;
import matrix.util.*;


/**
 * Extension of the stackimpl. Redifines the insert method and the pop method in order
 * to make it work with decimal numbers. This class is used in the postfixExpresions 
 * exercise. Allows to do mathematical operations (+ and *) in the structure.
 * 
 * @author JSaez
 */

public class StackImplOper extends StackImpl{
        
    public CDT insert(Object key) {
        
        if ((key.toString().indexOf('+')!=-1)||(key.toString().indexOf('*')!=-1)){           
            
            if (this.hasNext()){
                Object top1 = ADTPop();
                Object top2 = ADTPop();
                               
                int a = Integer.parseInt(top1.toString());
                
                int b = Integer.parseInt(top2.toString());
                
                int aux;
                
                if (key.toString().indexOf('+')!=-1)
                    aux =a + b;
                else
                    aux= a * b;
                              
                return insert(new Key(aux + ""));
            }
            else{
                
                Note.show("aa","Invalid operation");
                return this;
                
            }
            
        }
        else{
            
            
            if (key == null)
                return this;
            if (key instanceof Key && ((Key) key).toString() == "")
                return this;
            
            //stack is empty
            if (((FDT) firstNode.getObject()).getElement() == null) {
                ((FDT) firstNode.getObject()).setElement(key);
                return this;
            }
            
            if (key instanceof MatrixComparable) {
                LinkedListImpl newNode = new LinkedListImpl();
                newNode.setElement(key);
                newNode.setNext((LinkedListImpl) firstNode.getObject());
                firstNode.setObject(newNode);
                return this;
            }
            if (key instanceof Table) {
                Table t = (Table) key;
                for (int i = 0; i < t.size(); i++)
                    insert(t.getObject(i));
                return this;
            }

            LinkedListImpl newNode = new LinkedListImpl();
            newNode.setElement(key);
            newNode.setNext((LinkedListImpl) firstNode.getObject());
            firstNode.setObject(newNode);
            return this;
        }
        
    }
    
    public Object ADTPop() {
        if (!ADTIsEmpty()) {
            Object top = getTopOfStack().getElement();
            delete(top);
            
            //Keys must be unwrapped - ask Ari about this
            if (top instanceof Key)
                return ((Key)top).toString();
            return top;
        }
        return null;
    }
    
    
    
    
    static final long serialVersionUID = -624180279085524919L;
}