package content.interfaces;

import matrix.animation.Animator;
import matrix.structures.FDT.FDT;

public interface StateLegality {

    
    /**
     * Returns whether the last state in this animator does not
     * violate any structural propeties (heap property, search structure properties etc.)
     * 
     * @param   structures struxtures used in this exercise
     * @param   animator animator that controls the structures
     * @return  is the last state legal in structural sense
     */    
    public boolean legalEndState(Animator animator, FDT[] structures);
    
    /**
     * Returns whether the given state does not
     * violate any structural propeties (heap property, search structure properties etc.)
     * 
     * @param   structures structures used in this exercise
     * @return  is the state legal in structural sense
     */
    public boolean legalState(FDT[] structures);
    
}
