/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: endOperation.java,v 1.11 2005/05/18 10:59:00 jlonnber Exp $ */

package matrix.animation;

import matrix.visual.VisualType;

/**
 * "Closing bracket" operation to encapsulate
 * atomic operations together in <code>Animator</code>.
 *
 * @see endOperation
 * @see Animator
 */
public class endOperation implements AnimatedOperation {

    public endOperation() {
    }

    public void undo() {
        VisualType.touch(null); // Visual hint: clear previously touched objcts
        // start of undo
    }

    public void redo() {
        // end of redo
    }

    public String toString() { return ")"; }

    static final long serialVersionUID = -5646173300080143148L;
}
