/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: markerOperation.java,v 1.10 2006/12/14 12:20:35 oseppala Exp $ */

package matrix.animation;

/**
 * Creates marker with specified string.
 *
 * @see Animator#rewind(String)
 * @see Animator#markerOperation(String)
 */
public class markerOperation implements AnimatedOperation {
    private String m;


    public markerOperation(String m) {
        this.m = m;
    }

    /**
     * is current marked asked marker
     *
     * @param m marker text to check.
     * @return true if and only if current marker has given <code>String</code>
     */
    public boolean isMarker(String m) {
        return this.m.equals(m);
    }

    public void undo() {
        // start of undo
    }

    public void redo() {
        // end of redo
    }

    public String toString(){
        return "Marker operation : "+m;
    }

    static final long serialVersionUID = 5352782291349086918L;
}
