/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: LabelDecoratorAdapter.java,v 1.7 2004/11/05 09:00:00 kstalnac Exp $ */

package matrix.decoration;

import java.util.ArrayList;
import matrix.util.Note;

/** This class is a trivial implementation of LabelDecorator. */
public class LabelDecoratorAdapter implements LabelDecorator {
    protected String nodeLabel = "";
    protected ArrayList  referenceLabel = new ArrayList();

    public boolean isLabelEnabled() { 
	return false;
    }
    
    public void setLabelEnabled(boolean b) {
    	Note.warning(this, "setLabelEnabled(boolean) not implemented.");
    }

    public void setLabel(String s) {
	nodeLabel = s;
    }

    public String getLabel() { 
	return nodeLabel; 
    }

    // public void setLabelColorDistribution(ColorDistribution s) {}

    // public ColorDistribution getLabelColorDistribution() {}
    
    public boolean isReferenceLabelEnabled() { 
	return false;
    }
    
    public void setReferenceLabelEnabled(boolean b) {
    	Note.warning(this, "setReferenceLabelEnabled(boolean) not implemented.");
    }

    public void setReferenceLabel(int i, String s) {
	referenceLabel.set(i, s);
    }

    public String getReferenceLabel(int i) { 
	return (String)referenceLabel.get(i); 
    }

    // public void setReferenceColorDistribution(ColorDistribution s) {}

    // public ColorDistribution getReferenceColorDistribution() {}
}

