package matrix.decoration;

public interface ReferenceInformationDecorator extends InformationDecorator {

	/** 
	 * Tells if information message can be shown in a separate box or frame
	 * @return true if label is shown
	 */
	public boolean isReferenceInfoBoxEnabled();
	
	/**
	 * Tells if information message can be shown in tooltips. 
	 * @return true if label is shown
	 */
	public boolean isReferenceToolTipInfoEnabled();
	
	/**
     * Gets the information for the i:th reference from this node
     * @param i the number of the reference
     * @return the tooltip text
     */
    public String getReferenceInformation(int i);

    /**
     * Sets the information for the i:th reference
     * @param i the number of the reference
     * @param s new tooltip text
     */
    public void setReferenceInformation(int i, String s);

	
	
}
