/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: Styled.java,v 1.4 2004/05/25 13:28:06 kstalnac Exp $ */

package matrix.decoration;

/**
 * Interface for classes that support StyleSheets. Stylesheets are a way
 * to manipulate the coloring of nodes and references, and to add labels to nodes.
 *
 * @author Jussi Nikander
 */

public interface Styled {

    /** 
     * Gets the StyleSheet for this Object.
     * @return the StyleSheet
     * @see StyleSheetAdapter 
     */
    public StyleSheet getStyleSheet();
}
