/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2005 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: ADT.java,v 1.16 2007/09/03 12:22:35 oseppala Exp $ */

package matrix.structures.ADT;

import matrix.structures.CDT.CDT;

/**
 * ADT interface. All the structures in matrix.structures.ADT.probe package
 * should implement this interface. In this way the ADT structures can be
 * identified. An ADT structure can be visualized by calling getCDT method
 * and, after that, visualizing the returned CDT structure. 
 * 
 */
public interface ADT {

	/**
	 * Returns the underlying CDT structure. an ADT structure should be 
	 * visualized by calling this method and visulizing the returned CDT 
	 * structure. If this method returns null, there are no underlying CDT
	 * structure and the ADT structure cannot be visualized.
	 * 
	 * @return underlying CDT structure on which ADT structure is based
	 */
	public CDT getCDT();
	
}
