package matrix.structures.ADT.probe;

import matrix.structures.CDT.CDT;
import matrix.structures.CDT.interfaces.PrioritySupplied;
import matrix.structures.CDT.probe.BinHeap;
import matrix.structures.CDT.probe.OrderedList;

import java.util.*;

public class PriorityQueue implements    matrix.structures.ADT.ADT,
                                            matrix.structures.ADT.PriorityQueue{
    
    private matrix.structures.ADT.PriorityQueue implementation;
    private static CDT currentFactory  = new BinHeap();    
    private static Map implementations = new HashMap();
    
    static{
    	implementations.put("Heap",        new BinHeap());
        implementations.put("OrderedList", new OrderedList());
    }
    
    public CDT getCDT(){
        return (CDT)implementation;
    }
    
    public PriorityQueue getNewInstance(String implementingClassName){
    	CDT factory = (CDT)implementations.get(implementingClassName);
        CDT newInstance = factory.getNewInstance();
        return new PriorityQueue(newInstance);
    }    

    public PriorityQueue(CDT implementation){
    	this.implementation = (matrix.structures.ADT.PriorityQueue)implementation;
    }
    
    public PriorityQueue(){
        implementation = (matrix.structures.ADT.PriorityQueue)currentFactory.getNewInstance();
    }
    
    public PrioritySupplied ADTdeleteMin(){
    	return implementation.ADTdeleteMin();
    }
    
    public void ADTinsert(PrioritySupplied inserted){
    	implementation.ADTinsert(inserted);
    }

    public boolean ADTIsEmpty(){
        return implementation.ADTIsEmpty();
    }
}
