package matrix.structures.FDT;

public interface Struct extends FDT {

    /**
     * Fetches the names of all fields in the struct
     * 
     * @return names of the fields
     */
    
    public String[] getFieldNames();
    
    /**
     *  Fetches the name of the i:th field in the struct
     * @param location the index of the field fetched
     * @return name of the field
     */
    
    public String getFieldName(int location);
    
    /**
     *  Fetches an array containing values of all fields in this struct.
     * @return an array containing values of all fields
     */
    
    public Object[] getFields();

    /**
     *  Fetches the value of the i:th field in the struct.
     *  
     * @param location the index of the field fetched
     * @return the value of the i:th field in the struct
     */
    
    public Object getField(int location);
    
    /**
     * Sets the value of one field
     * 
     * @param value the new value for the field
     * @param location the index of the field to be set
     */
    
    public void setField(Object value, int location);
    
}

