/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.structures.FDT;

/**
 * UndirectedGraph is a marker interface that tells to the visualisation that
 * the graph is to be visualised as undirected. The InsertVertex() -method
 * While it is not necessery that a class implementing UndirectedGraph is
 * truly undirected (meaning: for each pair of vertices(a,b) if there is
 * edge(a,b) there is also edge(b,a) and vice versa), it should be or
 * Graph traversing algorithms meant to be used in undirected graphs (for example
 * Kruskal's algorithm) might not work.
 *
 * @author Jussi Nikander
 */

public interface UndirectedGraph /* extends SimulationGraph */ {

    static final long serialVersionUID = 2811327840750639247L;
}
