/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
/* 24/05/2006 moved from package matrix.structures.FDT (vkaravir) */ 


package matrix.structures.FDT.advanced;

import matrix.structures.FDT.Array;

/**
 * This is under construction:
 * Interface for styled arrays in Matrix. The idea is to provide an interface to
 * support arrays indexed also other ways than by integers.
 */
public interface StyledArray extends Array {
    /**
     * Return the correct index name for i'th index.
     * Non-styled arrays do not implement this method and thus their representation
     * for the name of i'th index is the integer number i.
     */
    public String getIndexName(int address);

    static final long serialVersionUID = -4953462247530461991L;

}
