/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: CommonGraphImpl.java,v 1.15 2006/12/12 14:11:09 oseppala Exp $ */

package matrix.structures.FDT.probe;

import java.util.Vector;

import matrix.structures.FDT.*;
import matrix.structures.FDT.substructures.Vertex;
import matrix.structures.memory.*;
import matrix.util.Note;

/** A common graph implementation (UNFINISHED (has probabaly always been)
 * !!! SHOULD NOT BE USED AS IT IS !!!
 * 
 * THIS CLASS WILL NOW BE REMOVED!
 */
public class CommonGraphImpl implements Graph, Vertex {

    // element at position zero
    private final static int DATA = 0;
    private VirtualObject data;
    private VirtualArray graph;

    /** The constructor for an empty graph. */
    public CommonGraphImpl() {
        data  = new VirtualObject(this, "data of the node");
        graph = new VirtualArray(this, "Successors of the node");
    }

    /** The constructor for a new root node. */
    public CommonGraphImpl(Object obj) {
        data  = new VirtualObject(this, "data of the node");
        graph = new VirtualArray(this, "SUccessors of the node");
        setElement(obj);
    }

    // CDT (not actually defined as an interface)

    /** Return the element value. */
    public Object getElement() {
        return data.getObject();
    }

    /** Set the element value. */
    public void setElement(Object v) {
        data.setObject(v);
    }

    // Methods for interface Array

    /** @return object at specified index. */
    public Object getObject(int index) {
        if (index == DATA)
            return data.getObject();
        return graph.getObject(index-1);
    }

    /** Set object at specified index. */
    public void setObject(Object o, int index) {
        if (index == DATA)
            setElement(o);
        else
            Note.show(this, "Illegal operation");
    }

    /** @return the value of the first index. */
    public int getFirst() {
        return 0;
    }

    /** @return the value of the last index. */
    public int getLast() {
        return graph.size()+1;
    }

    public Graph getNewNode(Object key) {
        return new CommonGraphImpl(key);
    }

    public String toString() {
        if (getElement() instanceof Key)
            return getElement().toString();
        else {
            String s = "null";
            if (getElement() != null) s = getElement().getClass().toString();
            return super.toString() + "(" + s + ")";
        }
    }


    private boolean visited = false;

    private void setVisited() {
        visited = !visited;
    }

    // Methods for interface Graph (NOT IMPLEMENTED PROPERLY!!!!)
    
    public synchronized Vertex[] getVertices() {
        boolean visitedTrue = !visited;
        Vector nodes = new Vector();
        nodes.addElement(this);
        int nextToVisit = 0;
        while (nextToVisit < nodes.size()) {
            CommonGraphImpl node =
                (CommonGraphImpl)nodes.elementAt(nextToVisit++);
            if (node.visited == visitedTrue) continue;
            node.setVisited();
            Vertex[] subGraph = node.getSuccessors();
            for (int i=0; i<subGraph.length; i++)
                nodes.addElement(subGraph[i]);
        }
        Vertex[] v = new Vertex[nodes.size()];
        nodes.copyInto(v);
        return v;
    }

    public void setVertices(Vertex[] v) {
        // TODO implementation for this method        
    }

    public void addVertex(Object o) {
        // TODO implementation for this method
    }

    public void removeVertex(Vertex v) {
        // TODO implementation for this method        
    }

    // Methods for interface Vertex (NOT IMPLEMENTED PROPERLY!!!!)

    public Vertex[] getSuccessors() {
        Vertex[] succ = new Vertex[graph.size()];
        for (int i=0; i<graph.size(); i++)
            succ[i] = (Vertex)graph.getObject(i);
        return succ;
    }

    public void setSuccessors(Vertex[] v) {
        // TODO implementation for this method        
    }
    
    public void addSuccessor(Vertex v) {}

    public void removeSuccessor(Vertex v) {}


    static final long serialVersionUID = 4427042463178194026L;

}
