package matrix.structures.FDT.probe;

import java.io.Serializable;

/** Class for edges of a <code>GeometricGraph</code>. Implemented this way
 * in order to make it easier to have several different kinds of edge
 * implementations. For example, if a DCEL is used the edges need to store
 * certain kind of information that is not required when we just wish
 * to draw a geometric graph.
 * 
 * @author jtn
 *
 */

public class GeometricEdge implements Serializable {

	private int v1, v2;
	
	public GeometricEdge(int i, int j) {
		v1 = i;
		v2 = j;
	}
	
	public int getSource() {
		return v1;
	}
	
	public int getDestination() {
		return v2;
	}
}
