/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */
package matrix.structures.adaptation;

import matrix.structures.FDT.substructures.Vertex;

public class GraphNodeAdapter extends Adapter implements Vertex {
    private Vertex[] successors;
    private Object key;

    public GraphNodeAdapter(Object key) {
        setElement(key);
    }

    public String getName() {
        return getElement().toString();
    }

    /**
     * @return the key of this Node.
     */
    public Object getElement() {
        return key;
    }

    /**
     * Sets the key of this Node.
     * @param o the new value of this Element
     */
    public void setElement(Object o) {
        key = o;
    }

    /**
     * Retuns the successor nodes of this vertes.
     *@return the successor nodes of this vertex.
     */
    public Vertex[] getSuccessors() {
        return successors;
    }

    public void setSuccessors(Vertex[] succ) {
        successors = succ;
    }

    static final long serialVersionUID = -9168530552510771809L;

    public void addSuccessor(Vertex v) {
        // TODO Auto-generated method stub
        
    }

    public void removeSuccessor(Vertex v) {
        // TODO Auto-generated method stub
        
    }
}
