/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.structures.code;


/**
 * This is the interface for code representation.
 * @author Ari Korhonen
 * @version 1.0
 */

public interface Code {
    /** @return the array of codelines in the representation. */
    String getCodeName();
    /** @return the codelines for the code representation */
    CodeLine[] getCodeLines();
    /** @return logical time (int) during the execution of the algorithm code */
    int getTime();
    /** @return an array including all the variables and data 
     *  structured involved in the algorithm. 
     */
    String[] getVariables();
    /** @return an array including all the descriptions the variables should have.
     */
    String[] getVariableDescription();
}
