/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.structures.coordinates;

import java.io.Serializable;

/**
 * The FDT interface is the fundamental interface of all data types in
 * Matrix. While it is possible to implement abstract data types without
 * using the FDT interface, there always must be some FDT that is manipulated
 * for Matrix to be able to visualise the data strcuture. It is recommended
 * that all data structures added to Matrix implement this interface.
 */
public interface StaticXYCoordinates extends Serializable {

    /** @return x coorinate for given vertex */
    int getX(int vertex);
    
    /** @return y coorinate for given vertex */
    int getY(int vertex);
    
    /** Set x and y coorinates for the given vertex */
    void setCoordinates(int vertex, int x, int y); 
}
