package matrix.structures.spatial.FDT.probe;

import java.awt.geom.GeneralPath;
import java.awt.geom.Point2D;

import matrix.structures.spatial.PaintingStyleDecorator;

public class Polygon extends PolyLine{

	public Polygon() {
		super();
	}
	
    public Polygon(Point[] p) {
        this(p, "");
    }

        
    public Polygon(Point[] p, String key) {
		super(p, key);
		GeneralPath path = getPath();
		path.lineTo((float)p[0].getX(), (float)p[0].getY());
	}
	
	public Polygon(double[] x, double[] y, String key) {
		super(x,y,key);
		GeneralPath path = getPath();
		path.lineTo((float)x[0], (float)y[0]);
	}

    public Polygon(Point2D[] p) {
        this(p, "");
    }

    public Polygon(Point2D[] p, PaintingStyleDecorator psd) {
        this(p, "");
        this.setPaintingStyleDecorator(psd);
    }

    public Polygon(Point2D[] p, String key) {
        super(p, key);
        GeneralPath path = getPath();
        //path.lineTo((float)p[0].getX(), (float)p[0].getY());
        path.closePath();
    }

    public boolean equals(Object o) {
		if(o instanceof Polygon) {
			return spatialEquals(o) && 
			getComparisonString().equals(((Polygon)o).getComparisonString());			
		}
		return false;
	}
	
}
