/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.uitools;

import java.awt.*;
import javax.swing.*;

public class History extends JFrame {
    private static History singleton = null;
    private StructurePanel structurePanel;
    private Dimension size;

    private History(StructurePanel sp) {
	super("History");
	structurePanel = sp;
	setVisible(false);
    }

    public static History getHistory(StructurePanel sp) {
	if (singleton == null) {
	    singleton = new History(sp);
	}
	return singleton;
    }

    public void paintComponent(Graphics g) {
	//super.paint(g);
	Image i = structurePanel.getOffscreen();
	int w = getSize().width;
	int h = getSize().height;

	if (i != null) {
	    Image im = i.getScaledInstance(w,h,0);
	    g.drawImage(im, 1, 1, this);
	}
    }
}



