package matrix.uitools.actions;

import java.awt.event.ActionEvent;

import javax.swing.Action;
import javax.swing.ImageIcon;

import matrix.animation.Animator;

public class AnimatorForwardAction extends AbstractMatrixAction {
	
    private static final long serialVersionUID = -5656789912773593943L;
    public static final String DEFAULT_NAME = "Forward";
	public AnimatorForwardAction() {
		super(DEFAULT_NAME);
		init();
	}
	
	public void actionPerformedOn(ActionEvent event) {
	    Animator animator = getFrame().getStructurePanel().getAnimator();
	    if (!animator.hasNextOperation()) {
	        setEnabled(false);
	        return;
	    }
	    if ((event.getModifiers() & ActionEvent.SHIFT_MASK) != 0)
	        animator.GoTo(animator.getState() + 1, animator.getMaximum());
	    else
	        animator.redo();
	    getFrame().getStructurePanel().getVisualAnimator().fireActionEvent(new ActionEvent(this, event.getID(), null));                
	    getFrame().validate();
	}
	
	private void init() {
	    ImageIcon ii = getImageIcon("pics/StepForward16.gif");
	    if (ii != null)
	        putValue(Action.SMALL_ICON, ii);
        putValue(Action.SHORT_DESCRIPTION, "Moves the animator one step forward. If you hold down the SHIFT-key, moves only one microstep.");
        setEnabled(false);
	}
	
    public void updateState() {
        setEnabled(getFrame().getStructurePanel().getAnimator().hasNextOperation());
    }
}
