/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

/* $Id: QueryString.java,v 1.11 2005/12/20 08:57:05 kstalnac Exp $ */

package matrix.util;

import java.awt.FlowLayout;
import javax.swing.*;
import java.awt.event.*;

public class QueryString extends JDialog {
        JDialog dial;
        JTextField tf;
        JButton ok, cancel;
        String txt;
        
        public QueryString(JFrame f, String title, String text) {
            super(f, title);
            setLocation(300,300);
            this.txt = text;
            //Note.out(this, "txt = " + txt);
            this.getContentPane().setLayout(new FlowLayout());
            this.setModal(true);
            tf = new JTextField(text, text != null ? text.length()+10 : 20);
	    tf.addKeyListener(new KeyListener() {
		    public void keyPressed(KeyEvent e) {
			if (e.getKeyCode() == KeyEvent.VK_ENTER)
			    ok();
		    }
		    public void keyReleased(KeyEvent e) {}
		    public void keyTyped(KeyEvent e) {}
		});
            ok = new JButton("Ok");
            cancel = new JButton("Cancel");
            getContentPane().add(tf);
            getContentPane().add(ok);
            getContentPane().add(cancel);
            ok.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) { ok(); }
            });
            cancel.addActionListener(new ActionListener() {
                public void actionPerformed(ActionEvent e) { cancel(); }
            }); 
            this.pack();
            this.setVisible(true);
        }
        
        public void ok() {
            //Note.out(this, "Ok " + txt);
            txt = tf.getText();
            dispose();
        }
        
        public void cancel() {
            //Note.out(this, "Cancel " + txt);
            dispose();
        }
        
        public static String ask(JFrame f, String title, String txt) {
            QueryString qs = new QueryString(f, title, txt);
            //Note.out(null, "return " + qs.txt);
            return qs.txt;
        }

    public static String ask(String title, String txt) {
	JFrame f = new JFrame();
	return ask(f, title, txt);
    }

}
        
