/*
 * Matrix -- algorithm simulation system
 * Copyright (C) 2000-2004 Matrix group
 * (See the AUTHORS file and the author tag below for more information
 * on the authors.)
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

package matrix.visual;

import java.awt.Graphics;

import matrix.structures.FDT.FDT;
import matrix.structures.code.Code;

/**
 * This is a text component wrapper class to allow VisualCode (container)
 * to include VisuaTextPanel (another container).
 *
 * @author Ari Korhonen
 * @version $Revision: 1.6 $
 */
public class VisualTextComponent extends VisualComponent {
    private VisualTextPanel vtp;
    private Code code;

    public VisualTextComponent(Code code) {
        super(null);
        this.code = code;
    }

    public void addComponents() {
        super.addComponents();
        if (getComponentCount() == 0)
            add(vtp = new VisualTextPanel(code));
    }

    public VisualType getVisualType() { return vtp; }

    public FDT getKey() { return null; }

    public void assign() {}

    public void setCode(Code code) { vtp.setCode(code); }

    public void paintComponent(Graphics g) { super.paintComponent(g); }

}


