// MatrixPro - algorithm simulation system
// Copyright (C) 2000-2007 See the AUTHORS file and the author tag
// below for more information on the authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package matrixpro.ui;

import java.awt.Frame;

import javax.swing.JFrame;
import javax.swing.JMenuItem;

import matrix.uitools.StructurePanel;

public class AppletFrame extends MainFrame {

    private static final long serialVersionUID = 6618763415889949661L;

    public void quit() {
        Frame[] frames = getFrames();
        for (int i = 0; i < frames.length; i++)
            frames[i].dispose();
    }

    public void close() {
        dispose();
    }

    public AppletFrame() {
        super();
    }

    public AppletFrame(StructurePanel p) {
        super(p);
    }

    public JFrame getNewFrame() {
        return new AppletFrame();
    }

    public JFrame getNewFrame(StructurePanel p) {
        return new AppletFrame(p);
    }

    public JMenuItem createRecentMenu() {
        JMenuItem recent = new JMenuItem("Open recent");
        recent.setEnabled(false);
        return recent;
    }
}
