// MatrixPro - algorithm simulation system
// Copyright (C) 2000-2007 See the AUTHORS file and the author tag
// below for more information on the authors.
//
// This program is free software; you can redistribute it and/or modify
// it under the terms of the GNU General Public License as published by
// the Free Software Foundation; either version 2 of the License, or
// (at your option) any later version.
//
// This program is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
// GNU General Public License for more details.
//
// You should have received a copy of the GNU General Public License
// along with this program; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package matrixpro.util.html;

import javax.swing.text.Element;
import javax.swing.text.View;
import javax.swing.text.html.HTML;
import javax.swing.text.html.HTMLEditorKit;

public class ResourceHTMLFactory extends HTMLEditorKit.HTMLFactory {

    public ResourceHTMLFactory() {
        super();
    }

    public View create(Element elem) {
        if (elem.getName().equalsIgnoreCase("IMG")) {
            String src = elem.getAttributes().getAttribute(HTML.Attribute.SRC)
                    .toString();
            if (src.startsWith("http") || src.startsWith("file"))
                return super.create(elem);
            else
                return new ResourceImageView(elem);
        } else
            return super.create(elem);
    }
}
